

:-op(1200,xfx,'::=').
:- dynamic (::=)/2.
:- discontiguous (::=)/2.


type ::= description.

modality ::= +complete.

axiom ::= enumeratedClass( c, { annotation }, {i} ).
classComparison ::= sameClassAs(description).
classComparison ::= disjointWith(description).
classComparison ::= subClassOf(description).

description ::= c.
description ::= restriction.
description ::= unionOf( {description}, {classComparison} ).
description ::= intersectionOf( {description}, {classComparison} ).
description ::= complementOf( description, {classComparison} ).
description ::= oneOf( { i }, { classComparison } ).

axiom ::= description.

restriction ::= restriction( cdp, value(dataLiteral) ).
restriction ::= restriction( cop, value( i ) ).
restriction ::= restriction( tp, value( i ) ).

smallInt ::= +naturalNumber .

text(comment) ::=
   ['These rules broadens the scope of restrictions, domain and range conditions.'].
classInRestriction ::= description .

dataRange ::= oneOf( {dataLiteral} ).
text(rationale) ::=
  ['Using the same dataRange in multiple range constraints
    of restrictions requires too much repetition without 
    allowing ',link(dr),'.'].
axiom ::= dataRange( dr, {annotation}, {dataLiteral} ).
text(rationale) ::=
  ['A datarange declaraion which does not identify the individuals is not useful,
    except perhaps to document the intended range of a datatype property.
    However, it does make the proofs easier, and the special cases fewer.'].
axiom ::= dataRange( dr, +declaration, {annotation} ).